//PROGRAMM FOR UART
//
// PROCESSOR : PIC18LF8490
// CLOCK	 : 20MHz, EXTERNAL

#include <p18f6585.h>
#include "usart.h"
#include <delays.h>
#include <usart.h>

#define bytes_for_USART_buffer 12

void interrupt_service_rutine_rda(void); 

static char USART_buffer[bytes_for_USART_buffer];   // bufer
static signed char USART_nextRec;  			// indikator na bufera
signed char Command;						// komanda
const char WhatAmI = 'M';	// identifikatori: vid ustroistvo
const char WhoAmI = '1';				// nomer na ustr.
const char Command_Execute = 'X';		// komanda za izpylnenie	
const char end_of_transmit = '!';   	// krai na predavane
char receive[6];

char message[]="S2X!";
char message1[]="Test2";
//Just simple delay
void Delay(unsigned long cntr) {
	while (--cntr != 0);
}

unsigned char ch;
void USART_add_to_buffer(char c){

USART_buffer[USART_nextRec++]=c;
  if(USART_nextRec==bytes_for_USART_buffer){
    USART_nextRec=0;
  }

  if(c==end_of_transmit){
    --USART_nextRec;
    if(USART_buffer[USART_nextRec-3]==WhatAmI){
      if(USART_buffer[USART_nextRec-2]==WhoAmI){
        if(USART_buffer[USART_nextRec-1]==Command_Execute){
          Command=0x01;
        }
      }
    }
    USART_nextRec = 0;
  }
}


void interrupt_service_rutine_rda(void) {

  char USART_nextChar;

  USART_nextChar='\0';
  if(ReadUSART()){
    USART_nextChar=UsartReadChar();
    USART_add_to_buffer(USART_nextChar);
  }
}

// main function
void main( void ) {

lcd_init();
	// Init UART
	//InitUsart();
OpenUSART(USART_TX_INT_OFF &
		  USART_RX_INT_OFF &
		  USART_ASYNCH_MODE &
		  USART_EIGHT_BIT &
		  USART_CONT_RX &
		  USART_BRGH_HIGH,
		  103);

USART_activa_tx();
putsUSART(message);
Delay1KTCYx(10);	
//lcd_write_text(message,5);
USART_activa_rx();

getsUSART(receive,5);
Delay1KTCYx(10);	
lcd_write_text(receive,5);
Delay1KTCYx(10);	

	while(1) {
	}
}



