//PROGRAMM FOR UART
//
// PROCESSOR : PIC18LF8490
// CLOCK	 : 20MHz, EXTERNAL

#include <p18f6585.h>
#include "usart.h"
#include <usart.h>
#include <delays.h>
#include "lcd4bit.h"
#include <xlcd.h>

#define bytes_for_USART_buffer 12

static char USART_buffer[bytes_for_USART_buffer];   // bufer
static signed char USART_nextRec;  			// indikator na bufera
signed char Command;						// komanda
const char WhatAmI = 'S';	// identifikatori: vid ustroistvo
const char WhoAmI = '1';				// nomer na ustr.
const char Command_Execute = 'X';		// komanda za izpylnenie	
const char end_of_transmit = '!';   	// krai na predavane
char receive[6];
char message[]= "Test1";
char error[]="Error";

int i;
//Just simple delay
void Delay(unsigned long cntr) {
	while (--cntr != 0);
}

unsigned char ch;
void USART_add_to_buffer(char c){

USART_buffer[USART_nextRec++]=c;
  if(USART_nextRec==bytes_for_USART_buffer){
    USART_nextRec=0;
  }

  if(c==end_of_transmit){
    --USART_nextRec;
    if(USART_buffer[USART_nextRec-3]==WhatAmI){
      if(USART_buffer[USART_nextRec-2]==WhoAmI){
        if(USART_buffer[USART_nextRec-1]==Command_Execute){
          Command=1;
        }
      }
    }
    USART_nextRec = 0;
  }
}

void buf()
{
	if(receive[0]==WhatAmI&receive[1]==WhoAmI){
		 Command=1;
		}
if(receive[0]!=WhatAmI||receive[1]!=WhoAmI){
		Command=0;
		}
	}

//#pragma interrupt interrupt_service_rutine_rda
void interrupt_service_rutine_rda(void) {

  char USART_nextChar;

  USART_nextChar='\0';
 
    USART_nextChar=UsartReadChar_nonstop();
    USART_add_to_buffer(USART_nextChar);
}

// main function
void main( void ) {

OpenUSART(USART_TX_INT_OFF &
		  USART_RX_INT_OFF &
		  USART_ASYNCH_MODE &
		  USART_EIGHT_BIT &
		  USART_CONT_RX &
		  USART_BRGH_HIGH,
		  103);

lcd_init();

USART_activa_rx();
getsUSART(receive,5);
Delay1KTCYx(10);

Command=0;

buf();

if (Command = 1)
{
Command=0;
lcd_write_text(receive,5);
Delay1KTCYx(10);	
}
else
{
lcd_write_text(error,5);
}
	
USART_activa_tx();
//putrsUSART("Received respond: ");
putsUSART(receive);
USART_activa_rx();

while(1); 

}



